include "FixedCode.inc"
include "VVram.inc"
include "Vram.inc"
include "Chars.inc"


ext PollVSync_
ext AsciiPatternSource_, MonoPatternSource_, ColorPatternSource_
ext VVramFront_, RowFlags_

VramTop equ Vram


dseg
Backup:
    defs VVramWidth*VVramHeight

cseg
MakeDouble:
    ld bc,0c000h
    do
        rlca
        if c
            ex af,af'
                ld a,c
                or b
                ld c,a
            ex af,af'
        endif
        srl b | srl b
    while nz | wend
ret


; void InitAsciiPattern();
cseg
InitAsciiPattern_: public InitAsciiPattern_
    push af | push hl | push de | push bc
        di
            ld hl,AsciiPatternRam
            ld de,AsciiPatternSource_
            ld bc,CharHeight*AsciiCount
            do
                push bc
                    ld a,(de) | inc de
                    call MakeDouble
                    ld (hl),c | inc hl
                    call MakeDouble
                    ld (hl),c | inc hl
                pop bc
                dec bc
                ld a,c
                or b
            while nz | wend
        ei
    pop bc | pop de | pop hl | pop af
ret


; void InitMonoPattern();
cseg
Colors:
    defb 4,02h
    defb 4,03h
    defb 0
InitMonoPattern_: public InitMonoPattern_
    push af | push hl | push de | push bc
        di
            ld hl,PatternRam
            ld de,MonoPatternSource_
            ld bc,Colors
            do
                ld a,(bc) | inc bc
                or a
            while nz
                exx
                    ld e,a ; count
                exx
                ld a,(bc) | inc bc ; color
                push bc
                    exx
                        ld b,a ; color
                        ld a,e ; count
                    exx
                    ld b,a ; count
                    do
                        exx
                            ld a,b
                            rrca | rrca
                            and 0c0h
                            ld d,a ; fore color
                            
                            ld a,b
                            rlca | rlca
                            and 0c0h
                            ld e,a ; back color
                        exx
                        push bc
                            ld c,4
                            do
                                ld a,(de) | inc de ; source byte
                                ld b,2
                                do
                                    push bc
                                        exx
                                            ld c,0
                                            ld l,e
                                            ld h,d
                                        exx
                                        ld b,4
                                        do
                                            exx
                                                rlca
                                                push af
                                                    if c
                                                            _deb: public _deb
                                                        ld a,c
                                                        or h
                                                        ld c,a
                                                    else
                                                        ld a,c
                                                        or l
                                                        ld c,a
                                                    endif
                                                    srl h | srl h
                                                    srl l | srl l
                                                pop af
                                            exx
                                        dwnz
                                        push af
                                            exx
                                                ld a,c
                                            exx
                                            ld (hl),a | inc hl
                                        pop af
                                    pop bc
                                dwnz
                                dec c
                            while nz | wend
                        pop bc
                    dwnz
                pop bc
            wend
        ei
    pop bc | pop de | pop hl | pop af
ret


; void InitColorPattern();
cseg
InitColorPattern_: public InitColorPattern_
    push hl | push de | push bc
        di
            ld hl,ColorPatternSource_
            ld de,PatternRam+CharHeight*Char_Enemy
            ld bc,(Char_End-Char_Enemy)*CharHeight
            ldir
        ei
    pop bc | pop de | pop hl
ret


; void ClearScreen();
ClearScreen_:   public ClearScreen_
    push af | push hl | push de | push bc
        call ClearVram

        ld hl,Backup
        ld bc,VVramWidth * VVramHeight
        do
            ld (hl),0
            inc hl
            dec bc
            ld a,c
            or b
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


PatternAddressDE:
    ex de,hl
        ld l,a
        ld h,0
        add hl,hl ;*2
        add hl,hl ;*4
        add hl,hl ;*8
        ld bc,PatternRam
        add hl,bc
    ex de,hl
ret


; word Put(word vram, byte c);
cseg
Put_: public Put_
    push af | push hl | push de | push bc
        ld a,e
        call PatternAddressDE
        di
            call Put8
        ei
    pop bc | pop de | pop hl | pop af
    inc hl
ret


VVramToVramRow:
    exx
        push de | push bc
    exx

    ld b,VVramWidth/2
    do 
        push bc
            ld a,(de) | inc de
            ld c,a
            cp (hl)
            if nz
                ld (hl),a | inc hl
                ld a,(de) | inc de
                ld b,a
                ld (hl),a | inc hl
                jr rowput
            else
                inc hl
                ld a,(de) | inc de
                ld b,a
                cp (hl)
                if nz
                    ld (hl),a | inc hl
                    rowput:
                    ld a,c
                    or a
                    if z
                        exx
                            call Clear8                    
                        exx
                    else
                        exx
                            call PatternAddressDE
                        exx
                        ld a,b
                        exx
                            push hl
                                or a
                                if z
                                    call Put8
                                    jr rowputend
                                endif
                                dec a
                                if z
                                    call Clear4
                                    ld bc,VramRowSize/2
                                    add hl,bc
                                    call Put4
                                    jr rowputend
                                endif
                                dec a
                                if z
                                    push de
                                        inc de | inc de | inc de | inc de
                                        call Put4
                                    pop de
                                    ex de,hl
                                        ld bc,CharHeight*4
                                        add hl,bc
                                    ex de,hl
                                    ld bc,VramRowSize/2
                                    add hl,bc
                                    call Put4
                                else
                                    inc de | inc de | inc de | inc de
                                    call Put4
                                    ld bc,VramRowSize/2
                                    add hl,bc
                                    call Clear4
                                endif
                                rowputend:
                            pop hl
                        exx
                    endif
                else
                    inc hl
                endif
                exx
                    inc hl
                exx
            endif
        pop bc
    dwnz
    exx
        ld bc,VramRowSize-VVramWidth/2
        add hl,bc

        pop bc | pop de
    exx
ret


; void VVramToVramAll();
VVramToVramAll_: public VVramToVramAll_
    push af | push hl | push de | push bc
        ld de,VVramFront_
        ld hl,Backup
        exx
            ld hl,Vram
        exx
        ld c,VVramHeight
        do
            call VVramToVramRow
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


; void VVramToVramChanged();
VVramToVramChanged_: public VVramToVramChanged_
    push af | push hl | push de | push bc
        ld de,VVramFront_
        ld hl,Backup
        exx
            ld hl,Vram
            ld de,RowFlags_
            ex de,hl
                ld c,1
                ld b,(hl)
                inc hl
            ex de,hl
        exx
        ld c,VVramHeight ; vertical count    
        do
            exx
                ld a,b
                and c
            exx
            if nz
                call VVramToVramRow            
            else
                push bc
                    ld bc,VVramWidth
                    add hl,bc
                    ex de,hl
                        add hl,bc
                    ex de,hl
                pop bc
                exx
                    push bc
                        ld bc,VramRowSize
                        add hl,bc
                    pop bc
                exx
            endif
            exx
                sla c
                if z
                    ex de,hl
                        ld c,1
                        ld b,(hl)
                        inc hl
                    ex de,hl
                endif
            exx
            dec c
        while nz | wend

        xor a
        ld (RowFlags_),a
        ld (RowFlags_+1),a
        ld (RowFlags_+2),a
    pop bc | pop de | pop hl | pop af
ret


; word PrintC(word vram, byte c);
PrintC_: public PrintC_
    push af | push hl | push de | push bc
        ld a,e
        sub ' '
        add a,a ;*2
        add a,a ;*4
        ex de,hl
            ld l,a
            ld h,0
            add hl,hl ;*8
            add hl,hl ;*16
            ld bc,AsciiPatternRam
            add hl,bc
        ex de,hl
        call PrintC
    pop bc | pop de | pop hl | pop af
    inc hl | inc hl
ret
